VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsApplication"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian. S.Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' The list of all plugins
Public Plugins As New Collection

' Our terminal object
Public Terminal As clsTerminal

' Used to perfom serveral file-related tasks
Public FileOperation As New clsFileOperation

' Contains different settings
Public Settings As New clsSettings

Public Sub ExitApp(Optional Caller As Form)

    ' Close all forms beside the caller
    CloseForms Caller
    
    ' Save the settings, in case it isn't already done
    Terminal.SaveSettings
    
    ' Remove all sessions
    Terminal.ClearAll
    
    ' Clear the class as well
    Set Terminal = Nothing
    
    ' And clear the application
    Set Application = Nothing

End Sub

Public Sub CloseForms(Optional Exception As Form)

    Dim Form As Form
     
    ' Go through all forms, ...
    For Each Form In Forms
        ' ... removing them all.
        If Not (Form Is Exception) Then
            Unload Form
        End If
    Next

End Sub

Public Sub LoadPlugins()

    On Error Resume Next
    Dim sFile As Variant, Plugin As Object, strClassName As String
    
    ' Go through all executable files in the plugin-folder
    For Each sFile In FileOperation.RetriveFileList(FileOperation.ValidPath(App.Path) & "Plugins\", "*.dll", False, vbNormal)
    
        ' Check the file type
        Select Case FileOperation.GetFileExtension(CStr(sFile))
            Case "dll"

                ' Clear all errors
                Err.Clear
                
                ' How the class is registered in the registry
                strClassName = FileOperation.GetNoExtension(FileOperation.GetFileName(CStr(sFile))) & ".PluginMain"
                
                ' Try to create the object
                Set Plugin = CreateObject(strClassName)
        
                If Err = 429 Then ' ERROR: ActiveX component can't create object
                    
                    ' Clear the error
                    Err.Clear
                    
                    ' Try to register the object
                    Shell "regsvr32 /s " & Chr(34) & CStr(sFile) & Chr(34)
                    
                    ' Load the plugin again
                    Set Plugin = CreateObject(strClassName)
                
                End If
        
                ' Now, if this didn't work either, it could be something wrong with the registration of the DLL, so we'll retry
                If Err = 429 Then
                
                    ' Firstly, clear the error
                    Err.Clear
                    
                    ' Then, unregister the DLL
                    Shell "regsvr32 /u /s " & Chr(34) & CStr(sFile) & Chr(34)
                    
                    ' And register it again
                    Shell "regsvr32 /s " & Chr(34) & CStr(sFile) & Chr(34)
                
                    ' Try to load the plugin for the last time
                    Set Plugin = CreateObject(strClassName)
                
                End If
                
                ' If even this dosen't work, we'll just ignore the whole thing
                If Err <> 429 Then
        
                    ' Add plugin
                    Plugins.Add Plugin, Plugin.Name
                
                    ' Initialize plugin
                    Plugin.Initialize Me
    
                End If

        End Select
        
    Next

End Sub

Public Property Get LoadedForms() As Collection

    ' Return the collection of loaded forms
    Set LoadedForms = Forms

End Property

