VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLogging"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Inform that a line has been logged
Public Event LineAppeneded(Line As String)

' The file of which this logging operation logs to
Public FileName As String

' Time stamps - the format of the time, as well as whether or not to enable it
Public TimeStamps As Boolean
Public TimeFormat As String

' String to use at the end of each line (used as it not always clear whether or not the
' class should automatically append a line terminater).
Public LineEnd As String

' Whether or not this log has been initialized
Public Initialized As Boolean

Public Sub AppendLine(sLine As String)

    Dim Free As Long, sPretext As String
    
    ' If the class hasn't been initialied, ...
    If Not Initialized Then
        ' ... stop.
        Exit Sub
    End If

    ' Retrieve a free file-socket
    Free = FreeFile
    
    ' Add timestamps if needed
    If TimeStamps Then
        sPretext = Format(Now, TimeFormat)
    End If

    ' Open the assigned file name
    Open FileName For Binary As #Free

        ' Append the line
        Put #Free, LOF(1) + 1, sPretext & sLine & LineEnd
    
    ' Close the file
    Close #Free
    
    ' Inform about this
    RaiseEvent LineAppeneded(sLine)
    
End Sub

Public Sub InitializeLog(sFileName As String)

    ' Set the file name
    FileName = sFileName

    ' Inform that logging has begun
    Initialized = True
    
End Sub

