VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsShell"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' API Declarations
Private Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As Long, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function CreatePipe Lib "kernel32" (phReadPipe As Long, phWritePipe As Long, lpPipeAttributes As SECURITY_ATTRIBUTES, ByVal nSize As Long) As Long
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Private Declare Function PeekNamedPipe Lib "kernel32" (ByVal hNamedPipe As Long, lpBuffer As Any, ByVal nBufferSize As Long, lpBytesRead As Long, lpTotalBytesAvail As Long, lpBytesLeftThisMessage As Long) As Long
Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDst As Any, pSrc As Any, ByVal ByteLen As Long)

' Used to access the pipes
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As Any) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Any) As Long

' Different execute-flags
Private Const INFINITE = -1&
Private Const WAIT_TIMEOUT = 258
Private Const STILL_ACTIVE = &H103&

' Flags used to determine what variables to use, among other things.
Public Enum StartFlags
    STARTF_USESHOWWINDOW = &H1
    STARTF_USESIZE = &H2
    STARTF_USEPOSITION = &H4
    STARTF_USECOUNTCHARS = &H8
    STARTF_USEFILLATTRIBUTE = &H10
    STARTF_RUNFULLSCREEN = &H20
    STARTF_FORCEONFEEDBACK = &H40
    STARTF_FORCEOFFFEEDBACK = &H80
    STARTF_USESTDHANDLES = &H100
End Enum

' Used to specify more creation flags
Public Enum ProcessCreationFlags
    CREATE_SUSPENDED = &H4
    DETACHED_PROCESS = &H8
    BELOW_NORMAL_PRIORITY_CLASS = &H4000
    ABOVE_NORMAL_PRIORITY_CLASS = &H8000
    NORMAL_PRIORITY_CLASS = &H20
    IDLE_PRIORITY_CLASS = &H40
    HIGH_PRIORITY_CLASS = &H80
    REALTIME_PRIORITY_CLASS = &H100
    CREATE_NEW_CONSOLE = &H10
    CREATE_NEW_PROCESS_GROUP = &H200
    CREATE_UNICODE_ENVIRONMENT = &H400
    CREATE_SEPARATE_WOW_VDM = &H800
    CREATE_SHARED_WOW_VDM = &H1000
    CREATE_FORCEDOS = &H2000
    CREATE_DEFAULT_ERROR_MODE = &H4000000
    CREATE_NO_WINDOW = &H8000000
End Enum

' The console colors to utilize
Public Enum ConsoleColor
    FOREGROUND_RED = &H4
    FOREGROUND_INTENSITY = &H8
    FOREGROUND_GREEN = &H2
    FOREGROUND_BLUE = &H1
    BACKGROUND_BLUE = &H10
    BACKGROUND_GREEN = &H20
    BACKGROUND_RED = &H40
    BACKGROUND_INTENSITY = &H80
End Enum

' De different start positions for graphical applications
Public Enum enSW
    SW_HIDE = 0
    SW_NORMAL = 1
    SW_MAXIMIZE = 3
    SW_MINIMIZE = 6
End Enum

' Used to provide the necessary information to the exectuable
Private Type STARTUPINFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

' Contains information about a process
Private Type PROCESS_INFORMATION
   hProcess As Long
   hThread As Long
   dwProcessID As Long
   dwThreadID As Long
End Type

' Used in creating a pipe
Private Type SECURITY_ATTRIBUTES
  nLength As Long
  lpSecurityDescriptor As Long
  bInheritHandle As Long
End Type

' Startup-settings
Public Title As String
Public Desktop As String
Public X As Long
Public Y As Long
Public Width As Long
Public Height As Long
Public Flags As StartFlags
Public ConsoleWidth As Long
Public ConsoleHeight As Long
Public ConsoleColors As ConsoleColor
Public ProcessFlags As ProcessCreationFlags
Public ProcessID As Long
Public ProcessHandle As Long
Public ThreadID As Long
Public ThreadHandle As Long
Public ShowWindow As enSW

' Handles to the different pipes
Public StdInputRead As Long
Public StdInputWrite As Long
Public StdOutputRead As Long
Public StdOutputWrite As Long

' The different shell events
Public Event ShellExecuting()
Public Event ShellInput(Data() As Byte)

' Whether or not we're currently executing
Public Running As Boolean

Public Function Execute(Command As String, Optional AppPath As String) As Boolean

    Dim Proc As PROCESS_INFORMATION, Pipe As SECURITY_ATTRIBUTES
    Dim Start As STARTUPINFO, Ret As Long, Pipe2 As SECURITY_ATTRIBUTES
    
    ' Do not reexecute if we're already doing so
    If Running Then
        Exit Function
    End If
    
    ' If the string is empty, ...
    If LenB(Command) = 0 Then
        ' ... set the string pointer to zero.
        Command = vbNullString
    End If
    
    ' Do the same thing with the other string as well.
    If LenB(AppPath) = 0 Then
        AppPath = vbNullString
    End If
    
    ' Set default values
    Running = True
    
    ' Inform that we're now starting a process
    RaiseEvent ShellExecuting
    
    ' Automatically create handles
    If (Flags And STARTF_USESTDHANDLES) = STARTF_USESTDHANDLES Then
        
        ' Initialize security descriptor
        With Pipe
            .nLength = Len(Pipe)
            .lpSecurityDescriptor = 0
            .bInheritHandle = True
        End With
        
        ' Copy the above code
        LSet Pipe2 = Pipe
        
        ' Create the pipes
        CreatePipe StdInputRead, StdInputWrite, Pipe, 0
        CreatePipe StdOutputRead, StdOutputWrite, Pipe2, 0
        
    End If
    
    ' Initialize the STARTUPINFO structure
    With Start
        .cb = Len(Start)
        .dwFillAttribute = ConsoleColors
        .dwFlags = Flags
        .dwX = X
        .dwY = Y
        .dwXSize = Width
        .dwYSize = Height
        .dwXCountChars = ConsoleWidth
        .dwYCountChars = ConsoleHeight
        .hStdInput = StdInputRead
        .hStdError = StdOutputWrite
        .hStdOutput = StdOutputWrite
        .lpDesktop = Desktop
        .lpTitle = Title
        .wShowWindow = ShowWindow
    End With
    
    ' Start the shelled application
    Ret = CreateProcessA(AppPath, Command, 0&, 0&, 1&, ProcessFlags, 0&, 0&, Start, Proc)
    
    ' Make sure the call was successful
    If Ret <> 0 Then
        
        ' Save the process information
        With Proc
            ProcessID = .dwProcessID
            ProcessHandle = .hProcess
            ThreadID = .dwThreadID
            ThreadHandle = .hThread
        End With
        
        Do
           
            ' Read input
            If (Flags And STARTF_USESTDHANDLES) = STARTF_USESTDHANDLES Then
                ReadPipe StdOutputRead, StdOutputWrite
            End If
            
            ' Retrieve the current status (and wait a bit)
            GetExitCodeProcess ProcessHandle, Ret
            Sleep 10
            DoEvents
        
        ' Exit the loop when the application has ended
        Loop Until (Ret <> STILL_ACTIVE Or (Not Running))
        
        ' Get the current state again
        GetExitCodeProcess ProcessHandle, Ret
        
        ' If its still alive, kill it.
        If Ret = STILL_ACTIVE Then
            TerminateProcess ProcessHandle, 0
        End If
        
        ' Clean up
        CloseHandle ProcessHandle
        CloseHandle ThreadHandle
        
        ' Clear variables
        StdInputRead = 0
        StdInputWrite = 0
        StdOutputRead = 0
        StdOutputWrite = 0
       
        ' The call was sucessful
        Execute = True
       
    End If
    
    ' Reset variables
    Running = False

End Function

Private Sub ReadPipe(hPipeRead As Long, hPipeWrite As Long)

    Dim Result As Long, tMsg As Long, Ret As Long
    Dim lpBuffer(160) As Byte, lpReturn() As Byte

    ' To avoid the loop below to exit immediately
    Ret = 1
            
    ' Continue reading until we have nothing left
    Do Until Ret = 0

        ' Check to see if there is any unread data in the pipe. This check is nessasary,
        ' as the ReadFile function will hang if there is nothing in the pipe.
        Result = PeekNamedPipe(hPipeRead, ByVal 0&, 0, UBound(lpBuffer) - 1, Ret, tMsg)
        
        ' See if the pipe is empty
        If Result = 0 Or Ret <= 0 Then
            ' If it is, exit.
            Exit Do
        End If

        ' Clear the buffer
        Erase lpBuffer

        ' Close the write end of the pipe before reading from the read end of the pipe.
        CloseHandle hPipeWrite

        ' Read from the file
        If ReadFile(hPipeRead, lpBuffer(0), UBound(lpBuffer) - 1, Ret, ByVal 0&) Then

            ' Fit the data we recieved into a new buffer
            ReDim lpReturn(Ret - 1)
            
            ' Copy the content of the first into the return buffer
            CopyMemory lpReturn(0), lpBuffer(0), Ret
            
            ' Raise the event
            RaiseEvent ShellInput(lpReturn)
            
            ' Let the event be processed
            DoEvents

        Else
        
            ' Exit the loop
            Exit Do
        
        End If

    Loop

End Sub

Public Function WriteLine(aData() As Byte) As Long

    ' See if pipes are enabled
    If (Flags And STARTF_USESTDHANDLES) = STARTF_USESTDHANDLES Then
    
        ' Send the given data to the write pipe
        WriteLine = WriteFile(StdInputWrite, aData(0), UBound(aData) + LBound(aData) + 1, 0, ByVal 0&)

    End If

End Function

Private Sub Class_Initialize()

    ' Set default flags
    Flags = STARTF_USESTDHANDLES Or STARTF_USEFILLATTRIBUTE Or STARTF_USESHOWWINDOW
    ConsoleColors = FOREGROUND_INTENSITY ' Use white text and black background
    ProcessFlags = NORMAL_PRIORITY_CLASS
    ShowWindow = SW_HIDE

End Sub

Private Sub Class_Terminate()

    ' Stop the execution
    Running = False

End Sub
