VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Information regarding the current user
Public UserName As String
Attribute UserName.VB_VarUserMemId = 0
Public UserPassword As String

' The text to automatically execute when the user has logged on/off
Public OnLogon As String
Public OnLogoff As String

' When set, these properties grants the user the ability to execute the functions.
Public AllowLogon As Boolean
Public AllowLogoff As Boolean
Public AllowShell As Boolean
Public AllowSetCmd As Boolean
Public AllowSetPriv As Boolean
Public AllowSetAttr As Boolean
Public AllowList As Boolean
Public AllowAddUser As Boolean
Public AllowDelUser As Boolean
Public AllowShutdown As Boolean
Public AllowSend As Boolean

' Contains this users security level
Public SecurityLevel As Long

' The folder to execute applications from
Public HomeFolder As String

' The time this user expires
Public Expire As Date

' Contains the amount of sessions connected to this user
Public Sessions As Long

' The amount of sessions allowed (below zero is unlimited)
Public MaxSessions As Long

' The parent of the object
Public Parent As clsTerminal

Public Property Get XML(Name As String) As SaveTypes

    ' Return how the different properties should be saved
    Select Case LCase(Name)
        Case "username", "userpassword"
            XML = Save_Attribute
        Case "allowlogon", "allowlogoff", "allowshell", "allowlist", "allowadduser", "expire", _
              "allowdeluser", "allowsetpriv", "allowshutdown", "allowsetcmd", "allowsend", "onlogon", _
               "maxsessions", "allowsetattr", "securitylevel", "onlogoff", "homefolder"
            XML = Save_Element
        Case Else
            XML = Save_Disallow
    End Select

End Property

Public Function Clone() As clsUser
    
    ' Returns an exact replica of this class
    Set Clone = New clsUser
    
    ' Initialize its content
    With Clone
        .AllowAddUser = AllowAddUser
        .AllowDelUser = AllowDelUser
        .AllowList = AllowList
        .AllowLogoff = AllowLogoff
        .AllowLogon = AllowLogon
        .AllowSend = AllowSend
        .AllowSetAttr = AllowSetAttr
        .AllowSetCmd = AllowSetCmd
        .AllowSetPriv = AllowSetPriv
        .AllowShell = AllowShell
        .AllowShutdown = AllowShutdown
        .Expire = Expire
        .MaxSessions = MaxSessions
        .OnLogoff = OnLogoff
        .OnLogon = OnLogon
        .SecurityLevel = SecurityLevel
        .Sessions = Sessions
        .UserName = UserName
        .UserPassword = UserPassword
        Set .Parent = Parent
    End With

End Function

Public Function IsOK(Password As String)

    ' Return whether or not the password is correct
    IsOK = CBool(Password = UserPassword)

End Function

Public Sub ClearAll()

    ' Clear all references
    Set Parent = Nothing

End Sub

Private Sub Class_Initialize()

    ' Set the default date
    Expire = DateSerial(2099, 1, 1)
    MaxSessions = -1

End Sub
