VERSION 5.00
Begin VB.Form frmLogging 
   Caption         =   "Session - 12.05.2006"
   ClientHeight    =   7950
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9375
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   530
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   625
   Begin VB.CommandButton cmdExec 
      Caption         =   "&Exec"
      Height          =   255
      Left            =   8640
      TabIndex        =   3
      Top             =   7560
      Width           =   615
   End
   Begin VB.CommandButton cmdSend 
      Caption         =   "&Send"
      Height          =   255
      Left            =   8040
      TabIndex        =   2
      Top             =   7560
      Width           =   615
   End
   Begin VB.TextBox txtInput 
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   7560
      Width           =   7815
   End
   Begin VB.TextBox txtData 
      Height          =   7335
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   9135
   End
End
Attribute VB_Name = "frmLogging"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' The log file we'll be watching
Public WithEvents Log As clsLogging
Attribute Log.VB_VarHelpID = -1

' The sesson we're monitoring
Public WithEvents Session As clsSession
Attribute Session.VB_VarHelpID = -1

' Used to load text from files
Private FileInput As New clsFileOperation

Private Sub cmdExec_Click()

    ' Here we will act as if the input came from the client.
    SendTextbox txtInput, True

End Sub

Private Sub cmdSend_Click()

    ' Send the textbox's content
    SendTextbox txtInput

End Sub

Private Sub SendTextbox(Textbox As Textbox, Optional Execute As Boolean)

    ' Inform about this to the client
    Session.SendData Textbox.Text & vbCrLf

    ' If set, execute the data
    If Execute Then
        Session.DataRecieved Textbox.Text & vbCrLf, True
    End If
    
    ' Clear and initiate the textbox
    Textbox.Text = ""
    Textbox.SetFocus
    
End Sub

Private Sub Form_Resize()

    ' Resize the control
    If Me.WindowState <> 1 Then
        txtData.Width = Me.ScaleWidth - txtData.Left - 8
        txtData.Height = Me.ScaleHeight - txtData.Top - txtInput.Height - 16
        txtInput.Top = txtData.Top + txtData.Height + 8
        txtInput.Width = txtData.Width - 8 - (cmdSend.Width * 2)
        cmdSend.Top = txtInput.Top
        cmdExec.Top = txtInput.Top
        cmdSend.Left = txtInput.Left + txtInput.Width + 8
        cmdExec.Left = cmdSend.Left + cmdSend.Width
    End If

End Sub

Private Sub Log_LineAppeneded(Line As String)

    Dim sText As String
    
    ' Retrieve the current text
    sText = txtData.Text

    ' Add this line to the text box as well
    txtData.Text = sText & Line

    ' Select the last part of the text
    txtData.SelStart = Len(sText) + Len(Line)

End Sub

Public Sub InitializeLog(oSession As clsSession, oLog As clsLogging)

    Dim sData As String

    ' Firstly, reference objects
    Set Log = oLog
    Set Session = oSession
    
    ' Then, load the file it has logged to
    sData = FileInput.LoadFile(Log.FileName)
    
    ' Copy this to the text box
    txtData.Text = sData
    
    ' Select the last part of the text
    txtData.SelStart = Len(sData)
    
    ' Finally, set the caption and show the form
    Session_SessionUserLoggedIn
    Me.Show
    
End Sub

Private Sub Session_SessionClosed()

    ' Do the same as below
    Session_SessionExiting

End Sub

Private Sub Session_SessionExiting()

    ' Free references
    Set Session = Nothing
    Set Log = Nothing
    Set FileInput = Nothing

    ' Close this form as well
    Unload Me

End Sub

Private Sub Session_SessionUserLoggedIn()

    ' Update the title
    Me.Caption = "Session " & Session.CurrentUser.UserName & " (" & Session.SessionStart & ")"

End Sub

Private Sub txtInput_KeyDown(KeyCode As Integer, Shift As Integer)

    ' See if the user pressed ENTER
    If KeyCode = 13 Then
    
        ' Send the given text
        SendTextbox txtInput
        
        ' Do not use this keycode
        KeyCode = 0
    
    End If

End Sub
