VERSION 5.00
Begin VB.MDIForm frmMain 
   BackColor       =   &H8000000C&
   Caption         =   "TelnetServer"
   ClientHeight    =   8880
   ClientLeft      =   165
   ClientTop       =   855
   ClientWidth     =   11070
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "MDIForm1"
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picStatusbar 
      Align           =   2  'Align Bottom
      BorderStyle     =   0  'None
      Height          =   375
      Left            =   0
      ScaleHeight     =   25
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   738
      TabIndex        =   0
      Top             =   8505
      Width           =   11070
      Begin VB.Timer tmrSecond 
         Interval        =   1000
         Left            =   10560
         Top             =   0
      End
      Begin TelnetGUI.usrStatusbar usrStatusbar1 
         Height          =   375
         Left            =   0
         TabIndex        =   1
         Top             =   0
         Width           =   11055
         _ExtentX        =   19500
         _ExtentY        =   661
      End
   End
   Begin VB.Menu mnuServer 
      Caption         =   "&Server"
      Begin VB.Menu mnuStart 
         Caption         =   "Start"
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuStop 
         Caption         =   "Stop"
         Shortcut        =   {F3}
      End
      Begin VB.Menu mnuLine1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSettings 
         Caption         =   "Settings"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuLine2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "Exit"
         Shortcut        =   ^Q
      End
   End
   Begin VB.Menu mnuUsers 
      Caption         =   "&Users"
      Begin VB.Menu mnuShowOnline 
         Caption         =   "Show online"
         Shortcut        =   {F4}
      End
      Begin VB.Menu mnuShowRegistered 
         Caption         =   "Show registered"
         Shortcut        =   {F5}
      End
      Begin VB.Menu mnuLine3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAddUser 
         Caption         =   "&Add user"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Our server module
Public WithEvents Terminal As clsTerminal
Attribute Terminal.VB_VarHelpID = -1

' Used to save all connection establishments
Public LogServer As New clsLogging

' Whether or not to intercept creation events
Private bIntercept As Boolean
Private bStarted As Boolean
Private bIgnoreEnd As Boolean

Private Sub MDIForm_Resize()

    ' Update the statusbar
    usrStatusbar1.SizeGrip = (Me.WindowState <> vbMaximized)

    ' Update the size
    If Me.WindowState <> 1 Then
        usrStatusbar1.Width = Me.Width / Screen.TwipsPerPixelX
    End If

End Sub

Private Sub MDIForm_Unload(Cancel As Integer)

    ' Save settings
    SaveSettings

    ' Unload application
    Application.ExitApp Me

End Sub

Private Sub MDIForm_Load()

    Dim oFile As clsFileOperation

    With usrStatusbar1
        
        ' Initialize statusbar
        .Initialize True, True
                             
        ' Add panels
        .AddPanel , , , sbNoAutosize
        .AddPanel , , , sbNoAutosize
        .AddPanel , 150, , sbNoAutosize
        .AddPanel , 150, , sbNoAutosize
        .AddPanel , 150, , sbNoAutosize
        .AddPanel , 150, , sbNoAutosize
        
        ' Update the content
        UpdateStatusBar
        
    End With

    ' Reference the file operation class
    Set oFile = Application.FileOperation
    
    ' Set the destination of the logs and settings
    Terminal.LogPath = oFile.ValidPath(App.Path) & "Logging\"
    Terminal.SettingsPath = oFile.ValidPath(App.Path) & "Settings\"
    
    ' Make sure the folders exist by creating them
    oFile.CreateDirectory Terminal.LogPath
    oFile.CreateDirectory Terminal.SettingsPath

    ' Initialize settings
    LoadSettings

    ' Load statisitcs
    Terminal.BytesRecieved = Application.Settings.BytesRecieved
    Terminal.BytesSent = Application.Settings.BytesSent
   
    ' See if we should start the server automatically
    If Application.Settings.AutoStart Then
        mnuStart_Click
    End If
   
End Sub

Private Sub mnuAddUser_Click()

    ' Intercept creation
    bIntercept = True

    ' Firstly, just create a new user (we'll intercept the creation event later on)
    Terminal.CreateUser "", ""

End Sub

Private Sub mnuServer_Click()

    ' Enable or disable alternatives
    mnuStart.Enabled = Not Terminal.Running
    mnuStop.Enabled = Terminal.Running

End Sub

Private Sub mnuSettings_Click()

    ' Firstly, initialize the settings
    frmSettings.LoadSettings
    
    ' Then, show the form.
    frmSettings.Show

End Sub

Private Sub mnuShowOnline_Click()

    ' Reference the class
    Set frmSessions.Terminal = Terminal

    ' Update the form
    frmSessions.UpdateContent

    ' Show the form
    frmSessions.Show

End Sub

Private Sub mnuShowRegistered_Click()

    ' Reference the class
    Set frmUsers.Terminal = Terminal

    ' Update the form
    frmUsers.UpdateContent

    ' Show the form
    frmUsers.Show

End Sub

Private Sub mnuStart_Click()

    On Error Resume Next
    
    ' Use this class
    With Terminal
    
        ' Clear all other errors
        Err.Clear
        
        ' As the class is automatically cleared before starting, we'll have to ignore
        ' the end event that it sends.
        bIgnoreEnd = True
        
        ' Start listening
        .Listen Application.Settings.ServerPort
        
        ' Inform about the error, if there's any
        If Err.Number <> 0 Then
            MsgBox "Error starting server: " & Err.Description, vbCritical, "Error"
            Exit Sub
        End If
        
        ' The server has now been started
        bIgnoreEnd = False
        bStarted = True
        
    End With

End Sub

Public Sub SaveSettings()

    Dim oSettings As New Collection
    
    ' Save statistics
    With Application.Settings
    
        ' Save the transmission statistics
        .BytesRecieved = Terminal.BytesRecieved
        .BytesSent = Terminal.BytesSent
        
        ' Do not add the time if the server isn't currently running
        If bStarted Then
            .TotalTime = .TotalTime + (Now - Terminal.ServerStarted)
        End If
        
    End With
    
    ' As the XML-file only can save collections, put the settings object in the collection
    oSettings.Add Application.Settings

    ' Save the settings
    Terminal.XML.SaveFile oSettings, Terminal.SettingsPath & "Settings.xml", "container"

End Sub

Public Sub LoadSettings()

    Dim oSettings As New Collection

    With Terminal
        
        ' Load the settings
        .LoadSettings
    
        ' Update terminal settigns
        UpdateSettings

        ' Add the settings object to this collection
        oSettings.Add Application.Settings

        ' Save the application settings
        Set oSettings = Terminal.XML.LoadFile(Terminal.SettingsPath & "Settings.xml")

        ' If we found anything, ...
        If oSettings.Count > 0 Then
            ' ... load the class
            Set Application.Settings = oSettings(1)
        End If

    End With

End Sub

Public Sub UpdateSettings()

    ' Load the server
    With Terminal
        .UseLogging = Application.Settings.UseLogging
        .LogonString = Application.Settings.WelcomeString
        .LogoffString = Application.Settings.GoodbyeString
    End With
    
    ' Initialize class
    Set LogServer = New clsLogging
    
    ' Update connection logging
    If Terminal.UseLogging Then
        With LogServer
            .InitializeLog Terminal.LogPath & "ServerEvents.txt"
            .TimeStamps = True
            .TimeFormat = "(dd.mm.yyyy hh:mm:ss) "
            .LineEnd = vbCrLf
        End With
    End If

End Sub

Private Sub mnuStop_Click()

    ' Close all forms but this
    Application.CloseForms Me

    ' Stop the server
    Terminal.ClearAll
    
    ' Add the time it ran
    With Application.Settings
        .TotalTime = .TotalTime + (Now - Terminal.ServerStarted)
    End With
    
    ' We're now currently not running the server
    bStarted = False

End Sub

Private Sub Terminal_ServerStarted()

    ' Log this
    If Terminal.UseLogging Then
        LogServer.AppendLine "Server started."
    End If

End Sub

Private Sub Terminal_ServerStopped()

    ' As the above
    If Terminal.UseLogging And (Not bIgnoreEnd) Then
        LogServer.AppendLine "Server stopped."
    End If

End Sub

Private Sub Terminal_SessionAttemptingLogon(Session As TelnetServer.clsSession, _
 RequestedUser As TelnetServer.clsUser, Cancel As Boolean)

    ' See if we actually have an user logging on
    If RequestedUser Is Nothing Then
        Exit Sub
    End If
    
    ' Inform that the session attempts to log on
    If Terminal.UseLogging Then
        ' No point informing this when it comes to the default user.
        If RequestedUser.UserName <> "Default" Then
            LogServer.AppendLine "Session (" & Session.RemoteHost & ") attempts to log on as " _
             & RequestedUser.UserName & "."
        End If
    End If

    ' See if this user has exceeded the amount of allowed logon attempts
    If Session.LogonAttempts >= Application.Settings.MaxLogonAttempts And _
     Application.Settings.MaxLogonAttempts >= 0 Then
    
        ' Disallow this logon
        Cancel = True
    
    End If

End Sub

Private Sub Terminal_SessionCreated(Session As TelnetServer.clsSession)

    ' Increase the amount of connections that has been made
    With Application.Settings
        .TotalConnections = .TotalConnections + 1
    End With
    
    ' Log this, if set
    If Terminal.UseLogging Then
        LogServer.AppendLine "Session (" & Session.RemoteHost & ") has connected to the server."
    End If

End Sub

Private Sub Terminal_SessionRemoving(Session As TelnetServer.clsSession)

    ' Inform about this, if logging is enabled.
    If Terminal.UseLogging Then
        LogServer.AppendLine "Session (" & Session.RemoteHost & ") has disconnected."
    End If

End Sub

Private Sub Terminal_UserCreating(User As TelnetServer.clsUser, Cancel As Boolean)

    ' If we're just created a new user, ...
    If bIntercept Then
    
        ' Stop intercepting
        bIntercept = False
        
        ' ... show the change user-dialog.
        frmChangeUser.InitializeUser User
        frmChangeUser.Show vbModal, Me
        
        ' If the user didn't create a new user, ...
        If frmChangeUser.Tag <> "OK" Then
            ' ... cancel the creation.
            Cancel = True
        End If
        
        ' Unload the form
        Unload frmChangeUser
    
    End If
    
End Sub

Private Sub Terminal_UserRequestedShutdown(Caller As clsUser)

    ' Inform about this
    If Terminal.UseLogging Then
        LogServer.AppendLine "Shutdown forced by " & Caller.UserName & "."
    End If

    ' Shutdown the program
    Application.CloseForms

End Sub

Public Sub UpdateStatusBar()

    ' Update the content
    With usrStatusbar1
        .PanelText(1) = "  Sessions: " & Terminal.Sessions.Count
        .PanelText(2) = "Bytes sent: " & Terminal.BytesSent
        .PanelText(3) = "Bytes recieved: " & Terminal.BytesRecieved
        .PanelText(4) = "Total connections: " & Application.Settings.TotalConnections
        .PanelText(5) = "Running time: " & IIf(Terminal.Running, CDate(Now - Terminal.ServerStarted), "N/A")
        .PanelText(6) = "Total time: " & Application.Settings.TotalTime + IIf(Terminal.Running, CDate(Now - Terminal.ServerStarted), 0)
    End With

End Sub

Private Sub tmrSecond_Timer()

    Dim Session As clsSession, iWait As Long

    ' Update the statusbar
    UpdateStatusBar
    
    ' Retrieve the maximum idle time
    iWait = Application.Settings.MaxIdle
    
    ' Make sure this functionality is enabled
    If iWait > 0 Then
    
        ' Go through all sessions ...
        For Each Session In Terminal.Sessions
        
            ' ... automatically closing those that exceeed the legal amount of IDLE time
            If DateDiff("s", 0, Session.SessionIdle) > iWait Then
                Session.ExitSession
            End If
        
        Next
        
    End If

End Sub
