VERSION 5.00
Object = "{BE4889FA-7C57-4D42-B6C8-7DFC60FC4B99}#18.0#0"; "VirtualListView.ocx"
Begin VB.Form frmSessions 
   Caption         =   "Sessions"
   ClientHeight    =   7965
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10275
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   531
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   685
   Begin VB.Timer tmrRefresh 
      Interval        =   1000
      Left            =   9720
      Top             =   7440
   End
   Begin VirtualListView.usrListView usrSessions 
      Height          =   7695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   9975
      _ExtentX        =   17595
      _ExtentY        =   13573
      LabelEdit       =   1
      SizeStyle       =   1
      HoverSelection  =   -1  'True
      Styles          =   "frmSessions.frx":0000
      Columns         =   "frmSessions.frx":1348
   End
   Begin VB.Menu mnuSession 
      Caption         =   "Session"
      Visible         =   0   'False
      Begin VB.Menu mnuTrack 
         Caption         =   "Track"
      End
      Begin VB.Menu mnuLine 
         Caption         =   "-"
      End
      Begin VB.Menu mnuKick 
         Caption         =   "Kick"
      End
   End
End
Attribute VB_Name = "frmSessions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Reference to the terminal
Public WithEvents Terminal As clsTerminal
Attribute Terminal.VB_VarHelpID = -1

Private Sub Form_Resize()

    ' Resize the control
    If Me.WindowState <> 1 Then
        usrSessions.Width = Me.ScaleWidth - 16
        usrSessions.Height = Me.ScaleHeight - 16
    End If
    
End Sub

Public Sub UpdateContent()

    ' See if this is a special case
    If Terminal.Sessions.Count < 1 Then
    
        ' Just use the default number
        usrSessions.RowsAmount = 1
        
        ' Update content
        usrSessions.UpdateContent
    
    Else

        ' Update the content of the list view
        If usrSessions.RowsAmount <> Terminal.Sessions.Count Then
            ' If the number of users has changed, update that.
            usrSessions.RowsAmount = Terminal.Sessions.Count
        Else
            ' Otherwise, just refresh the content.
            usrSessions.UpdateContent
        End If

    End If

End Sub

Private Sub mnuKick_Click()

    ' Make sure any element is selected
    If Not (usrSessions.SelectedItem Is Nothing) Then

        ' And that this element's reference is correct
        If usrSessions.SelectedItem.Row > 0 And usrSessions.SelectedItem.Row <= Terminal.Sessions.Count Then
            Terminal.KillSession Terminal.Sessions(usrSessions.SelectedItem.Row)
        End If
        
    End If

End Sub

Private Sub mnuTrack_Click()

    Dim frmLog As frmLogging

    ' Make sure anything is selected
    If Not (usrSessions.SelectedItem Is Nothing) Then
    
        ' If that selection is valid, ...
        If usrSessions.SelectedItem.Row > 0 And usrSessions.SelectedItem.Row <= Terminal.Sessions.Count Then
            
            ' Create a new form
            Set frmLog = New frmLogging
            
            ' ... show a form that contains the log for this session.
            frmLog.InitializeLog Terminal.Sessions(usrSessions.SelectedItem.Row), _
             Terminal.Sessions(usrSessions.SelectedItem.Row).Log

        End If
        
    End If

End Sub

Private Sub Terminal_SessionCreated(Session As TelnetServer.clsSession)

    ' Update the list of users
    UpdateContent

End Sub

Private Sub Terminal_SessionRemoving(Session As TelnetServer.clsSession)

    ' As the above
    UpdateContent

End Sub

Private Sub tmrRefresh_Timer()

    ' Updates the list of sessions each second
    UpdateContent

End Sub

Private Sub usrSessions_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    Dim oCell As clsCell

    ' If this is a right click, ...
    If Button = 2 Then
        
        ' See if any cell was selected
        Set oCell = usrSessions.HitTest(CLng(x), CLng(y))
        
        ' If any other cell WAS in fact found, select it
        If Not (oCell Is Nothing) Then
            usrSessions.SelectItem oCell.Column, oCell.Row
        End If
        
        ' ... show the menu, if any element is selected.
        If Not (usrSessions.SelectedItem Is Nothing) Then
            Me.PopupMenu mnuSession
        End If
        
    End If

End Sub

Private Sub usrSessions_RetrieveListItem(Item As VirtualListView.clsCell)

    ' Make sure this item exist
    If Item.Row > 0 And Item.Row <= Terminal.Sessions.Count Then
        ' Retrieve the correct value
        With Terminal.Sessions(Item.Row)
            Select Case Item.Column
                Case 1 ' ID
                    Item.Text = Item.Row
                Case 2 ' Remote host
                    If Not (.Socket Is Nothing) Then
                        Item.Text = .RemoteHost
                    End If
                Case 3 ' User name
                    If Not (.CurrentUser Is Nothing) Then
                        Item.Text = .CurrentUser.UserName
                    End If
                Case 4 ' Session start
                    Item.Text = .SessionStart
                Case 5 ' Session IDLE
                    Item.Text = .SessionIdle
                Case 6 ' Bytes sent
                    Item.Text = .BytesSent
                Case 7 ' Bytes recieved
                    Item.Text = .BytesRecieved
            End Select
        End With
    
    Else
        ' Reset the text if this element is invalid.
        Item.Text = ""
    End If

End Sub
