VERSION 5.00
Object = "{BE4889FA-7C57-4D42-B6C8-7DFC60FC4B99}#18.0#0"; "VirtualListView.ocx"
Begin VB.Form frmUsers 
   Caption         =   "Users"
   ClientHeight    =   8040
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10845
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   536
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   723
   Begin VirtualListView.usrListView usrUsers 
      Height          =   7695
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   9975
      _ExtentX        =   17595
      _ExtentY        =   13573
      LabelEdit       =   1
      SizeStyle       =   1
      HoverSelection  =   -1  'True
      Styles          =   "frmUsers.frx":0000
      Columns         =   "frmUsers.frx":1348
   End
   Begin VB.Menu mnuUser 
      Caption         =   "UserMenu"
      Visible         =   0   'False
      Begin VB.Menu mnuEdit 
         Caption         =   "Edit"
      End
      Begin VB.Menu mnuLine 
         Caption         =   "-"
      End
      Begin VB.Menu mnuRemove 
         Caption         =   "Remove"
      End
   End
End
Attribute VB_Name = "frmUsers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Reference to the terminal
Public WithEvents Terminal As clsTerminal
Attribute Terminal.VB_VarHelpID = -1

Private Sub Form_Resize()

    ' Resize the control
    If Me.WindowState <> 1 Then
        usrUsers.Width = Me.ScaleWidth - 16
        usrUsers.Height = Me.ScaleHeight - 16
    End If
    
End Sub

Public Sub UpdateContent()

    ' Update the content of the list view
    If usrUsers.RowsAmount <> Terminal.Users.Count Then
        ' If the number of users has changed, update that.
        usrUsers.RowsAmount = Terminal.Users.Count
    Else
        ' Otherwise, just refresh the content.
        usrUsers.UpdateContent
    End If

End Sub

Private Sub mnuEdit_Click()

    Dim oUser As clsUser

    ' Make sure any element is selected
    If Not (usrUsers.SelectedItem Is Nothing) Then

        ' Retrieve the user to edit
        Set oUser = Terminal.Users(usrUsers.SelectedItem.Row)
    
        ' Edit this user
        frmChangeUser.InitializeUser oUser
        frmChangeUser.Show vbModal
        
        ' If we changed anything, ...
        If frmChangeUser.Tag = "OK" Then
            ' ... update the list.
            UpdateContent
        End If

    End If

End Sub

Private Sub mnuRemove_Click()

    ' Make sure any element is selected
    If Not (usrUsers.SelectedItem Is Nothing) Then

        ' Delete the selected item
        Terminal.KillUser Terminal.Users(usrUsers.SelectedItem.Row).UserName
        
    End If

End Sub

Private Sub Terminal_UserListChanged()

    ' Update the content of the list
    UpdateContent

End Sub

Private Sub usrUsers_ItemChanged(Item As VirtualListView.clsCell)

    ' Use the current user
    With Terminal.Users(Item.Row)
         Select Case Item.Column
            Case 2 ' User name
                .UserName = Item.Text
            
            Case 3 ' User password
                .UserPassword = Item.Text
            
            Case 6 ' On logon
                .OnLogon = Item.Text
                
            Case 7 ' On logoff
                 .OnLogoff = Item.Text
            
            Case 10 ' Home folder
                .HomeFolder = Item.Text

            Case 4 ' Max sessions
            
                ' Make sure the value set is valid
                If IsNumeric(Item.Text) Then
                    .MaxSessions = Item.Text
                End If
                
            Case 5 ' Security level
                
                If IsNumeric(Item.Text) Then
                    .SecurityLevel = Item.Text
                End If
                
            Case 8 ' Expire
            
                ' Make sure this is a date
                If IsDate(Item.Text) Then
                    Item.Text = .Expire
                Else
                    MsgBox "Invalid value", vbCritical, "Cannot change!"
                End If
                
        End Select
    End With

End Sub

Private Sub usrUsers_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

    Dim oCell As clsCell

    ' If this is a right click, ...
    If Button = 2 Then
        
        ' See if any cell was selected
        Set oCell = usrUsers.HitTest(CLng(x), CLng(y))
        
        ' If any other cell WAS in fact found, select it
        If Not (oCell Is Nothing) Then
            usrUsers.SelectItem oCell.Column, oCell.Row
        End If
        
        ' ... show the menu, if any element is selected.
        If Not (usrUsers.SelectedItem Is Nothing) Then
            Me.PopupMenu mnuUser
        End If
        
    End If

End Sub

Private Sub usrUsers_RetrieveListItem(Item As VirtualListView.clsCell)

    ' Make sure this item exist
    If Item.Row > 0 And Item.Row <= Terminal.Users.Count Then
    
        ' Retrieve the correct value
        With Terminal.Users(Item.Row)
            Select Case Item.Column
                Case 1 ' ID
                    Item.Text = Item.Row
                Case 2 ' User name
                    Item.Text = .UserName
                Case 3 ' User password
                    Item.Text = .UserPassword
                Case 4 ' Max sessions
                    Item.Text = .MaxSessions
                Case 5 ' Security level
                    Item.Text = .SecurityLevel
                Case 6 ' On logon
                    Item.Text = .OnLogon
                Case 7 ' On logoff
                    Item.Text = .OnLogoff
                Case 8 ' Expire
                    Item.Text = .Expire
                Case 9 ' Sessions
                    Item.Text = .Sessions
                Case 10 ' Home folder
                    Item.Text = .HomeFolder
            End Select
        End With
    
    Else
        ' Reset text if element is invalid.
        Item.Text = ""
    End If

End Sub
