Attribute VB_Name = "modGlobal"
Option Explicit

' Copyright (C) 2006 Kristian. S.Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' Used to initialize XP themes
Declare Sub InitCommonControls Lib "Comctl32" ()

' Used to make text boxes numberic
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

' Constants used in the above
Const GWL_STYLE = (-16)
Const ES_NUMBER = &H2000&

' Our main application
Public Application As New clsApplication

Public Sub Main()
    
    ' Load common controls
    InitCommonControls
    
    ' Create a new instance
    Set Application.Terminal = New clsTerminal
    
    ' Reference this class
    Set frmMain.Terminal = Application.Terminal
    
    ' Load plugins
    Application.LoadPlugins
    
    ' Show the main form
    frmMain.Show

End Sub

Public Sub SetNumber(NumberText As Textbox, Flag As Boolean)
    
    Dim curstyle As Long, newstyle As Long

    ' Retrieve the window style
    curstyle = GetWindowLong(NumberText.hWnd, GWL_STYLE)

    If Flag Then
       curstyle = curstyle Or ES_NUMBER
    Else
       curstyle = curstyle And (Not ES_NUMBER)
    End If

    ' Set the new style
    newstyle = SetWindowLong(NumberText.hWnd, GWL_STYLE, curstyle)
    
    ' Refresh the control
    NumberText.Refresh
    
End Sub




